
import greenfoot.*;
import java.util.Date;
/**
 * Write a description of class Animator here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Animator 
{
       int spriteX = 0;
       int spriteY = 0;
       SpriteSheet mySheet = null;
       Counter hitCount = null;
       Animator myOpponent = null;
       Fighter myFighter = null;
       boolean isStanding = true;
       boolean isWalking = false;
       boolean isPunching = false;
       boolean isJumping = false;
       boolean isDucking = false;
       boolean isUppercuting = false;
       boolean isBlocking = false;
       boolean isKicking;
       boolean gotKicked = false;
       boolean XRange = false;
       boolean ouch = false;
       boolean blood = false;
       int walkFrameIndex = 0;
       int punchFrameIndex = 0;
       int hitCounter = 0;
       int sheetX = 0;
       int sheetY = 0;
       int count = 0;
       int t = 0;
       final int SPEED = 200;
       final int SPEED2 = 100;
       final int coolDown = 1000;
       final int longCoolDown = 2000;
       final int coolDown2 = 500;
       Date lastFrame = new Date();
       Date lastPunchTime = new Date();
       
       public void setSprites(SpriteSheet sheet)
       {
            mySheet = sheet;
       }
       
       public void setFighterOpponent(Fighter fight)
       {
           myFighter = fight;
       }
       
       public void setOpponent(Animator opponent)
       {
           myOpponent = opponent;
       }
       
       public GreenfootImage getDisplayImage()
       {
           if(isPunching){
                Date x = new Date();
                if(((x.getTime() - lastFrame.getTime()) > SPEED2) && (hitCounter < 3)){
                    punchFrameIndex ++;
                    lastFrame = x;
                }          
                if(((x.getTime() - lastFrame.getTime()) > SPEED) && (hitCounter == 3)){
                    punchFrameIndex ++;
                    lastFrame = x;
                    
                }   
                
                if(punchFrameIndex == 3){
                   punchFrameIndex = 0;
                   isPunching = false;
                   isStanding = true;
                   if(XRange &&  !myOpponent.getBlock() && !myOpponent.getDuck()){
                       Greenfoot.playSound("hitPunch.wav");
                       hitCount.bumpCount(5);
                       hitCounter++;
                       myOpponent.setOuch(true);
                   }else if(myOpponent.getBlock() && XRange){
                       myFighter.setKnockback(true, 5);
                    }
                   if((XRange && (hitCounter == 3) && !myOpponent.getDuck())){
                       myFighter.setKnockback(true, 20);
                       hitCount.bumpCount(9);
                       hitCounter = 0;
                    }
                   return getDisplayImage();
                }
                
                if(punchFrameIndex == 0){
                    punchFrameIndex = 1;
                }
                
                return mySheet.getSprite(punchFrameIndex, 1); 
           }
           
           if(isKicking){
                Date x = new Date();
                if((x.getTime() - lastFrame.getTime()) > SPEED){
                    lastFrame = x;
                    if((t == 0)&&(XRange &&  !myOpponent.getJump() && !myOpponent.getDuck())){
                       Greenfoot.playSound("kick.wav");
                    }
                    if(XRange &&  !myOpponent.getJump() && !myOpponent.getDuck() && (t == 0)){                       
                        hitCount.bumpCount(1);
                        myOpponent.setOuch(true);
                    }else if(myOpponent.getDuck() && XRange && (t == 0)){
                        myFighter.setKnockback(true, 5);
                    }
                    t++;
                }
                if(t > 1){
                    isKicking = false;
                    isDucking = true;
                    t = 0;
                    return getDisplayImage();
                }
                return mySheet.getSprite(1, 3); 
           }
           
           if (isWalking){
                Date x = new Date();
                if((x.getTime() - lastFrame.getTime()) > SPEED){
                    if(walkFrameIndex == 2){
                        Greenfoot.playSound("step.wav");
                    }else if(walkFrameIndex == 2){
                        Greenfoot.playSound("step.wav");
                    }
                    walkFrameIndex ++;
                    lastFrame = x;
                }
                
                if(walkFrameIndex == 3){
                   walkFrameIndex = 0;
                }
                return mySheet.getSprite(walkFrameIndex, 0); 
           }
           
           if (isJumping){
               return mySheet.getSprite(0, 2);
           }
           
           if(isUppercuting){
                Date x = new Date();
                if((x.getTime() - lastFrame.getTime()) > SPEED){
                    lastFrame = x;                  
                    if(t == 0){
                        if(XRange &&  !myOpponent.getJump() && !myOpponent.getDuck()){                       
                            hitCount.bumpCount(3);
                            Greenfoot.playSound("upperCut.wav");
                            myFighter.setHit(true);
                        }                   
                    }
                    t++;
                }               
                if(t > 1){
                    isUppercuting = false;
                    isDucking = true;
                    t = 0;
                    return getDisplayImage();                    
                }    
                return mySheet.getSprite(3, 1);     
           }
           
           if(blood){
               count ++;
               if(count > 3){
                   count = 0;
                   blood = false;
                }
               return mySheet.getSprite(1, 2);
            }
            
            if(ouch){
                count ++;
               if(count > 10){
                   count = 0;
                   ouch = false;
                }
                return mySheet.getSprite(0, 3);
            }
           
           if (isDucking){
               return mySheet.getSprite(2, 2);
           }
           if (isBlocking){
               return mySheet.getSprite(3, 2);
           }
           
           if (isStanding){
               return mySheet.getSprite(0, 0);
           }
           return mySheet.getSprite(0, 0);
       }
       
       public void setCount(Counter count)
       {
           hitCount = count;
       }
       
       public boolean getJump()
       {
           return isJumping;
       }
       
       public boolean getStanding()
       {
           return isStanding;
       }
       
       public boolean getWalking()
       {
           return isWalking;
       }
       
       public boolean getPunch()
       {
           return isPunching;
       }
       
       public boolean getDuck()
       {
           return isDucking;
       }
       
       public boolean getUppercut()
       {
           return isUppercuting;
       }
       
       public boolean getBlock()
       {
           return isBlocking;
       }
       
       public boolean getOppBlock()
       {
           return myOpponent.getBlock();
       }
       
       public void blood(boolean owe)
       {
           if(owe){
               ouch = true;
            }else{
                ouch = false;
            }
        }
        
        public void setKicking(boolean kick)
        {
            if(!kick){
               isKicking = false;
           }else{
                Date x = new Date();
                if(x.getTime() - lastPunchTime.getTime()  >= coolDown){
                   isKicking = true;
                   isWalking = false;
                   lastPunchTime = new Date();
                }
           }
        }
       
       public void setOuch(boolean owe)
       {
           if(owe){
               ouch = true;
            }else{
                ouch = false;
            }
       }
       
       public void setRange(boolean range)
       {
           if(!range)
           {
               XRange = false;
           }else{
               XRange = true;
            }
       }
       
       public void setJump(boolean jump)
       {
           if(!jump)
           {
               isJumping = false;
           }else{
               isJumping = true;
            }
       }
       
       public void setStanding(boolean stand)
       {
           if(!stand)
           {
               isStanding = false;
           }else{
               isStanding = true;
            }
       }
       
       public void setWalking(boolean walk)
       {
           if(!walk)
           {
               isWalking = false;
           }else{
               isWalking = true;
            }
       }
       
       public void setPunch(boolean Punch)
       {
           if(!Punch)
           {
               isPunching = false;
           }else{
               Date x = new Date();
               if((x.getTime() - lastPunchTime.getTime() >= longCoolDown)){
                   hitCounter = 0;
                }
               if((x.getTime() - lastPunchTime.getTime() >= coolDown) && (hitCounter == 2)){
                   isPunching = true;
                   lastPunchTime = new Date();
                }
                if((x.getTime() - lastPunchTime.getTime() >= coolDown2) && (hitCounter < 2)){
                   isPunching = true;
                   lastPunchTime = new Date();
                }
            }
       }
       
       public void setDuck(boolean duck)
       {
           if(!duck){
               isDucking = false;
           }else{
                isDucking = true;
                isWalking = false;
           }
       }
       
       public void setUppercut(boolean up)
       {
           if(!up){
               isUppercuting = false;
           }else{
                Date x = new Date();
                if(x.getTime() - lastPunchTime.getTime()  >= coolDown){
                   isUppercuting = true;
                   isWalking = false;
                   lastPunchTime = new Date();
                }
           }
       }
       
       public void setBlock(boolean block)
       {
           if(!block){
               isBlocking = false;
           }else{
                isBlocking = true;
                isWalking = false;
           }
       }
}
