 import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
 

/**
 * 
 * 
 * @Jacob Mandt 
 * @4/30/2020
 */
public class MyWorld extends World
{
    GifImage back;
    GreenfootImage temp;
    boolean keyPressed = false;
    boolean start = false;
    
    public MyWorld()
    {    
        super(600, 400, 1);
    }
    
    public void startGame()
    {
        start = true;
        back = new GifImage("Huh.gif");
        
        Fighter leftFighter = new Fighter();
        
        leftFighter.setLeftKeyboard(true);
        leftFighter.setName("Bob");
        leftFighter.setSpritePaths("leftBob.png", "rightBob.png");
        addObject (leftFighter, 300, Fighter.FLOOR_Y);

        
        
        Fighter rightFighter = new Fighter();
        
        rightFighter.setLeftKeyboard(false);
        rightFighter.setName("Jerry");
        rightFighter.setSpritePaths("leftJerry.png","rightJerry.png");
        addObject (rightFighter, 400, Fighter.FLOOR_Y);
        
        
        leftFighter.setOpponent(rightFighter);
        rightFighter.setOpponent(leftFighter);
        
        Counter bob = new Counter(leftFighter, rightFighter);
        addObject(bob,50,20);
        Counter jerry = new Counter(rightFighter, leftFighter);
        addObject(jerry,550,20);
    }
    
    public void paintOrder()
    {
        if((Greenfoot.getKey() != null) || Greenfoot.mouseClicked(null)){
            keyPressed = true;
        }
        if(keyPressed){
            if(!start){
                startGame();
            }
            temp = back.getCurrentImage();
            temp.scale(600, 400);
            setBackground(temp);
        }else{
            if(!start){
                setBackground("startScreen.png");
            }
        }
    }
    
    public void act()
    {
        paintOrder();
    }
    
}
